#include <mpi.h>
#include <stdio.h>

void my_int_sum_reduce(int *sendbuf, int *recvbuf, int count,
  int root, MPI_Comm comm)
{
  int size, rank;
  MPI_Comm_size(comm, &size);
  MPI_Comm_rank(comm, &rank);

  if (rank == root) {
    for (int j = 0; j < count; j++)  {
      recvbuf[j] = sendbuf[j];
    }

    int tmp[count];

    for (int i = 0; i < size; i++) {
      if (i == root)
        continue;
      MPI_Recv(tmp, count, MPI_INT, i, 0, comm, MPI_STATUS_IGNORE);
      for (int j = 0; j < count; j++) {
        recvbuf[j] += tmp[j];
      }
    }
  } else {
    MPI_Send(sendbuf, count, MPI_INT, root, 0, comm);
  }
}

int main(int argc, char **argv)
{
  MPI_Init(&argc, &argv);

  int size, rank;
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  int sendbuffer[4];
  int recvbuffer[4];

  for (int i = 0; i < 4; i++) {
    sendbuffer[i] = rank + i;
  }

  //MPI_Reduce(sendbuffer, recvbuffer, 4, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
  my_int_sum_reduce(sendbuffer, recvbuffer, 4, 0, MPI_COMM_WORLD);
  if (rank == 0) {
    for (int i = 0; i < 4; i++) {
      printf("%d ", recvbuffer[i]);
    }
    printf("\n");
  }

  MPI_Finalize();
}
